//+------------------------------------------------------------------+
//|                                                 KAMA classic.mq4 |
//|                                                                  |
//|              |
//+------------------------------------------------------------------+
#property copyright ""

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 White
#property indicator_width1 2


extern int periodAMA=5; // ,    
extern int sensor=1;    //   
extern int PriceType=6; // ,    
// 0   
// 1   
// 2   
// 3   
// 4  , (high+low)/2 
// 5  , (high+low+close)/3 
// 6   , (high+low+close+close)/4 

//---- buffers
double KAMA[],Signal[];
//+------------------------------------------------------------------+
//|                                             |
//+------------------------------------------------------------------+
double Price(int k)
  {
//----
   double res;
//----
   switch (PriceType)
      {
      case 1: res=Open[k]; break;
      case 2: res=High[k]; break;
      case 3: res=Low[k]; break;
      case 4: res=(High[k]+Low[k])/2.0; break;
      case 5: res=(High[k]+Low[k]+Close[k])/3.0; break;
      case 6: res=(High[k]+Low[k]+2*Close[k])/4.0; break;
      default: res=Close[k];break;      
      }
   return(res);
  }
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   if(periodAMA<=0) periodAMA=1;
//---- indicators
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS)); 
   IndicatorBuffers(2);
   
   SetIndexStyle(0,DRAW_LINE,0,2);
   SetIndexBuffer(0,KAMA);
   SetIndexEmptyValue(0,0.0);
   SetIndexDrawBegin(0,(periodAMA+2));
   
   SetIndexBuffer(1,Signal);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
//----
   return(0);  
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   if (Bars<=periodAMA+3) return(0);
   else 
     {
//   ,         
     int limit,counted_bars=IndicatorCounted(); 
     double AMA_1;
     if(counted_bars>0)
       {
//            
       counted_bars--;
       limit=Bars-counted_bars;
       } 
      else limit=Bars-periodAMA-2;    
     }
//  
   if(Signal[limit+1]>0) AMA_1=Signal[limit+1]; //     
   else AMA_1=Price(limit+1); //     
   
//  :
   for(int i=limit; i>=0; i--)
    {
//            
    double DiffPrice=MathAbs(Price(i)-Price(i+periodAMA));    
    double Noise=0.000000000001;
//      
    for(int k=0; k<periodAMA; k++) Noise+=MathAbs(Price(i+k)-Price(i+1+k));
//  (Efficiency Ratio)    1  0 
    double ER=DiffPrice/Noise; 
//    (scaled smoothing constant)    0,66667  0,06452    
    double SSC=(ER*0.60215)+0.06452; //   2  30- 
//    :
    Signal[i]=AMA_1+MathPow(SSC,2)*(Price(i)-AMA_1);
    Signal[i]=NormalizeDouble(Signal[i],Digits);
//   AMA    
    AMA_1=Signal[i]; 
    KAMA[i]=Signal[i];
    }
   for(i=limit; i>=0; i--)
    if(MathAbs(Signal[i]-Signal[i+1])<sensor*Point) KAMA[i]=KAMA[i+1];
//----
   return(0);
  }
//+------------------------------------------------------------------+